#!/usr/bin/python
"""
for a given file
for a given python dict
for each key in the dict
	go thru the file line by line
		find the pattern %%something%%
		if there is a dict{something} defined,

			substitute the value of dict{something for %%something%%
"""
import re
import sys
import os

def hashsubstitute(file_in,subdict):
	if file_in[-3:] != '.in':
		print "WARNING: Input file name [%s] doesn't end with '.in'"
	file_out = file_in[:-3]
	try:
		IN = open(file_in, "r")
	except:
		print("Input file [%s] open failed" % (file_in))
		exit()

	try:
		OUT = open(file_out, "w")
	except:
		print("Output file [%s] open failed" % (file_out))
		exit()
	rpat = re.compile('%%[A-Z_0-9]{2,20}%%')	# compile the RE
	#wholefile = IN.read() # read whole file
	line = IN.readline() # inits line
	while line: #
		# now have to find a %%something%%
		matches = rpat.findall(line)
		if matches: # if find any, strip to KEY and substitute
			for m in matches:
				key = m[2:-2] #strip the %%'s
				line = re.sub(m, subdict[key], line) #substitute in place
		# write out the processed line
		OUT.write(line)
		line = IN.readline() # read the next one

def main():

	subdict = {'USERNAME': 'hjmangalam',
			'HOSTNAME': 'flop.nacs.uci.edu',
			'EMAIL': 'hjm@tacgi.com',
			'ADMIN': 'harry mangalam',
			'BADNAME': 'floozy',
			'TEL': '949 856 2899',
			'CELL': '949 285 4487',
			}
	#ask for file name
	filename = raw_input("What file name do you want substituted?  ")
	hashsubstitute(filename,subdict)
	print "Done"


# now that all the code has been processed, start up main().
if __name__ == '__main__':
    main()
