from os import path, getcwd, mkdir
from commands import getoutput

class Constants:
	dummy = 0  #for debugging, can be removed after all is stable.
	def Check_UserGroup_Exists(self, user, fname="/etc/passwd"):
		from sys import exit
		gh = "grep " + user  + " " + fname + " |cut -f1 -d':'"
		#print gh
		ao = []
		ao = getoutput(gh).split("\n")
		for u in ao:
			if u == user:
				print "SUCCESS: [%s] exists in [%s]" % (user, fname)
				return 1
			#else: print "%s ?" % (u)
		print "FATAL: [%s] doesn't exist in [%s].  You'll have to fix this manually." % (user, fname)
		exit(1)
		#if getoutput(gh) == user:
			#print "SUCCESS: [%s] exists in [%s]" % (user, fname)
		#else:



	def Check_Dir(self, dir):
		from sys import exit
		if path.exists(dir): print "SUCCESS: [%s] exists! Continuing..." % (dir)
		else:
			print "WARN: %s doesn't exist. Will try to make it." % (dir)
			try: mkdir(dir)
			except:
				print "FATAL: Can't make [%s] for some reason - check permissions..?" % (dir)
				exit(1)

	def getSysConfig(self):
		#from os import path
		"""Provides a place to define the system-specific variables such as where certain
		   directories are located or what pre-existing names are.
		   On startup, webbackuppc will check that these variables exist and issue warnings
		   or try to create the dirs/files if not.  It will check for all the required
		   users and then quit with a warning if any of them do not already exist.
		"""
		cfg = {} # init hash
		cfg['OK']           = 0
		cfg['CFG_DIR']      = '/etc/BackupPC' # top level config dir
		cfg['BAK_DIR']      = 'backup' # CFG_DIR/BAK_DIR
		cfg['HTPASS_FNAME'] = 'htpasswd.4.backuppc' # CFG_DIR/HTPASS_FNAME
		cfg['HTPASSWD']     = '/usr/bin/htpasswd' # system htpasswd command
		cfg['PCPL_DIR']     = 'pc' # CFG_DIR/PCPL_DIR
		cfg['BUPC_USER']    = 'backuppc' # user who will run the cherrypy httpd service
		cfg['BUPC_GROUP']   = 'backuppc' # above user's group
		cfg['WEB_GROUP']    = 'www-data' # system web user if nec.
		cfg['BACKUPPC']     = 'BACKUPPC' # local cache for data to be written to CFG_DIR
		cfg['CWD']          = getcwd() # get current working dir
		print "\nINFO: starting from directory ", cfg['CWD']
		#cfg[''] = ''
		#cfg[''] = ''
		# Now check all the configs
		# 1st, does CFG_DIR exist and seem to be populated?
		if path.exists(cfg['CFG_DIR']):
			print "SUCCESS:[%s] exists! Continuing..." % (cfg['CFG_DIR'])
			# check BAK_DIR
			bd = cfg['CFG_DIR'] + '/' + cfg['BAK_DIR']
			self.Check_Dir(bd)
			# check PCPL_DIR
			pd = cfg['CFG_DIR'] + '/' + cfg['PCPL_DIR']
			self.Check_Dir(pd)
			lcd = cfg['BACKUPPC']
			self.Check_Dir(lcd)
			lcdpc = cfg['BACKUPPC'] + '/' + cfg['PCPL_DIR']
			self.Check_Dir(lcdpc)

			# check required bupc user
			self.Check_UserGroup_Exists(cfg['BUPC_USER'])
			# check required groups
			self.Check_UserGroup_Exists(cfg['BUPC_GROUP'],"/etc/group")
			self.Check_UserGroup_Exists(cfg['WEB_GROUP'], "/etc/group")
			# check htpasswd file
			htf = cfg['CFG_DIR'] + '/' + cfg['HTPASS_FNAME']
			if path.exists(htf):
				print "Great! %s exists! Continuing..." % (htf)
			else:
				print "ERR: %s doesn't exist; will try to make it and populate with user %s with password 'just4now'" % (htf, cfg['BUPC_USER'])
				htp_str = cfg['HTPASSWD'] + '-b -c ' + htf + ' ' + cfg['BUPC_USER'] + ' just4now'
				if path.exists(cfg['HTPASSWD']):
					try:
						system(htp_str)
					except:
						print "FATAL: Couldn't successfully execute cmd:\n[%s]" % (htp_str)
						sys.exit(1)
					print "SUCCESS: Initialized %s" % (htf)
				else:
					print "FATAL: You don't have %s installed!" % (cfg['HTPASSWD'])
					sys.exit(1)
		else:
			print "FATAL: %s doesn't even exist.  You probably haven't installed BackupPC", cfg['CFG_DIR']
			sys.exit(1)
		cfg['OK'] = 1 # if we got here, everything checks out so signal that!
		return cfg

	#Method to obtain the Service Agreement.
	def getSLA(self):
		"""Just opens an included file & reads it into a buffer for later emission """
		fp = open("rsync_src/SLA.txt","r")
		sla_text = fp.read() # now entire text is read into sla_text
		return sla_text
    #Method that contains the wording when there are errors on the form.
	def getErrorsOnForm(self):
		return 'Please correct the following errors:'
	def getRSyncHeaderTemplate(self):
		return """# rsyncd.conf configuration file
		# GLOBAL OPTIONS
		#max verbosity = 5
		auth users = %%USERNAME%%
		secrets file = C:\\rsyncd\\rsyncd.secrets
		# the only host in the next line should be 128.200.84.82 (the backup server)
		hosts allow = 128.200.84.82
		strict modes = no
		log format = %t: host %h (%a) %o %f (%l bytes). Total %b bytes.
		dont compress = *.gz *.tgz *.zip *.z *.rpm *.deb *.iso *.bz2 *.tbz *.exe
		"""
	def getTemplateBackup(self):
		return """
		[BACKUP]
		path = %%BACKUP_PATH%%
		use chroot = no
	max connections=1
	lock file = C:\\rsyncd\\rsyncd.lock
	# "read only = yes" is the safest, but means that you cannot do a direct restore to your disk
	#  direct restore is convenient, but an be quite dangerous (it overwrites existing files, so
	#  keep this as "read only = yes"
	read only = yes
	# following allows admin to debug connection if need be
	list = yes
	exclude from = C:\\rsyncd\\rsyncd.exclude
	ignore errors = yes
	ignore nonreadable = yes
	transfer logging = yes
	timeout = 600
	refuse options = checksum dry-run
        """
	def getErrorMkDir(self, rsyncdir):
		return "problem with mkdir with %s" % (rsyncdir)
	def getErrorWritingHostsFile(self):
		return "err in writing to hostfile"
	def getErrorInWritingBUPCHostInfoFile(self):
		return "err in writing to bupc host info file"
	def getEmailSubject(self):
		return "Your BackupPC rsyncd files"
	def getAdminEmail(self):
		return "harry.mangalam@uci.edu"
	def getAdminEmailSubject(self):
		return "[BACKUPPC] New Request"
	def getAdminEmailBody(self):
		return "rsync_src/AdminEmail.txt"

