import locale
import socket
#from configobj import ConfigObj# for the configuration module
from datetime import datetime
from turbogears import controllers, expose, error_handler, validate
from turbogears import flash, redirect, url
from turbogears import widgets, validators
from cherrypy import request
from Services import Services
from MyForms import BackupPCFields
from Constants import Constants
from MyValidators import BUPCFormSchema,TrueValidator,IpValidator,HostValidator
import sys

#for debugging purposes, this can be removed after reaching a stable state.
from IPython.Shell import IPShellEmbed
# and insert 'dbg()' where you want to break.
dbg = IPShellEmbed()

debugMode=False
# set the locale so that we can show the date in local format
locale.setlocale(locale.LC_ALL, '')
constants = Constants()
CFG = {} # hash that stores the system configuration variables set in Constants.py

# get / check System configuration variables
CFG = constants.getSysConfig()
if CFG['OK'] == 'NO':
    print >>sys.stderr, "Sorry - some system configuration issues remain. Please check errors above."
    sys.exit(1)

# instantiate the storage object

myfields = BackupPCFields()
myfields.setDebug(debugMode)
if not debugMode:
    backupPCForm = widgets.TableForm(fields=myfields,action="processRequest", validator=BUPCFormSchema())
else:
    backupPCForm = widgets.TableForm(fields=myfields,action="processRequest")

class Root(controllers.RootController):


    @expose(template='.templates.index')
    def index(self,tg_errors=None):
        #(L)Obtain data of the requesting host.
        #(L)CLIENT_FQDN = Client's Fully qualified Host name.
        #(L)CLIENT_IP = Client's IP address
        #(L){Q-A}CLIENT_LOCAL = Filled by gethostbyaddr but not used in this call (needed or won't compile)
        #client_fqdn,client_local,client_ip = gethostbyaddr(request.remoteAddr)
#<<<<<<< Version 29 It works for windows machines.
        #dbg()
        print >>sys.stderr, "########gethostbyaddr########"
        hn = ""
        ipAdd = ""
        try:
            (hn,alias,ips) = socket.gethostbyaddr(request.remoteAddr)
            ipAdd = socket.gethostbyname(hn);
        except:
            ipAdd = request.remoteAddr
        if hn == "":
            print >>sys.stderr, "ERR: no registered FQDN"
            flash("ERROR: the IP of your computer isn't registered to a network name!\nWithout that, we can't back you up, so take a donut to your network admin.")
            #redirect(url('/'))
#        hn = ""
#        ipAdd = ""
                    #addresses,dummy =getaddrs(request.remoteAddr);
#======= Version 30. this works for linux machines.
#        #dbg()
#        #(hn,alias,ips) = socket.gethostbyaddr(request.remoteAddr)
#        ra = request.remoteAddr
#        print >>sys.stderr, "the value of ra is: ",ra
#        if ra != '::1':
#            (hn,alias,ips) = socket.gethostbyaddr(ra.split(':')[3])
#        else: # a localhost attempt
#            (hn,alias,ips) = ("localhost","localhost","127.0.0.1" )
#        ipAdd= socket.gethostbyname(hn);
        #addresses,dummy =getaddrs(request.remoteAddr);
#>>>>>>> .r30
        #for debugging, can be completely removed after the site is complete.

        #try:
            #hn
        #except:
            #print >>sys.stderr, "ERR: no registered FQDN"
            #flash("ERROR: the IP of your computer isn't registered to a network name!\nWithout that, we can't back you up, so take a donut to your network admin.")
        print >>sys.stderr, "the value of client_ip is: ",ipAdd
        print >>sys.stderr, "the value of client_hostname is: ",hn
        constants.dummy = 0 # hjm set
        if constants.dummy == 0:
            constants.dummy=1
            # why are we testing this?  We want to do it each time, regardless
            #if len(backupPCForm.fields[2].attrs)==0: 
            backupPCForm.fields[2]=widgets.TextField(name='IPNUMBER', convert=True, field_class='textfield', attrs={'value':ipAdd}, css_classes=[], label="Client IP #")
            #if the HOSTNAME has no value, set it.
            # why are we testing this?  We want to do it each time, regardless
            #if len(backupPCForm.fields[3].attrs)==0:
            backupPCForm.fields[3]=widgets.TextField(name='HOSTNAME', convert=True, field_class='textfield', attrs={'size':30,'value':hn}, css_classes=[], label="Client Hostname")
        else:
            print >>sys.stderr, "skipping dummy=0 segment: ",ipAdd
            #ipvalue = backupPCForm.fields[2].attrs.get('value');
            #backupPCForm.fields[2]=widgets.TextField(name='IPNUMBER', convert=True, field_class='textfield', attrs={'value':ipvalue}, css_classes=[])
        #if the IP number has no value, set it.
        #IF THERE ARE FORM ERRORS: State so.
        if tg_errors:
            ipvalue = backupPCForm.fields[2].attrs.get('value');
            backupPCForm.fields[2]=widgets.TextField(name='IPNUMBER', convert=True, field_class='textfield', attrs={'value':ipvalue}, css_classes=[])
            flash(constants.getErrorsOnForm())
        return dict(form=backupPCForm)
    #**
    #This method is exposed to handle the request and also to handle possible errors on the form
    #found by the validator.
    #**
    @expose()
    @validate(form=backupPCForm)
    @error_handler(index)
    def processRequest(self, SLA, IPNUMBER, HOSTNAME, DHCP, WINVER, BACKUP_DIR, FIRSTNAME, LASTNAME, PHONE, USERNAME, PASSWORD1, PASSWORD2, EMAIL, LAPTOP=False, I_AGREE=False):
        #Call the services to handle the request.
        services = Services()
        services.execute(SLA,IPNUMBER,HOSTNAME,DHCP,WINVER,BACKUP_DIR,FIRSTNAME,LASTNAME,PHONE,USERNAME,PASSWORD1,PASSWORD2, EMAIL,LAPTOP,I_AGREE,debugMode)
        #Once handled redirect.
        redirect(url('/ThankYou'))
    # this is an example of an empty def - refers to a template which is essentially static HTML
    # requires no content from the corresponding def().  ... I think...
    @expose(template=".templates.thankyou")
    def ThankYou(self):
        return dict();
